<?php

    ini_set('memory_limit', '1024M');
    set_time_limit(0);
    ini_set('max_execution_time', 7200);
    ini_set('display_errors', 1);
    ini_set("log_errors", 1);
    ini_set("error_log", "mls_import.txt");
    error_reporting(E_ALL);
    date_default_timezone_set('America/Toronto');
    echo "<pre>";

    require 'library/aws/vendor/autoload.php';
    require_once("config/db_config.php");
    
    $dbcron      = new MysqliDb($servername, $db_username, $db_password, $dbname);
    $dbproperty  = new MysqliDb($servername, $db_username, $db_password, $dbname);
    
    
    geocode($dbproperty,$dbcron);
    
    function file_get_contents_curl($url) {
        $ch = curl_init();
    
        curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);       
    
        $data = curl_exec($ch);
        curl_close($ch);
    
        return $data;
    }

    function geocode($dbproperty,$dbcron) {
        $limit = 1000 ;
        echo $query    = "SELECT id,St_num,St_dir,St,St_sfx,Apt_num, ListingId, cityname,Municipality_district, postalcode, County from rets_property_data where Latitude='' or Latitude is null LIMIT $limit  ";
        $property_data = $dbcron->rawQuery($query);
        if (count($property_data) > 0) {
            $counter = 0 ;
            foreach($property_data as $property){
                $counter++;
                $curr_id = $property['id'];
                $u_data = array();
                $sysid   = $property['ListingId'] ;
                echo "<br>".$counter ;
                $Ml_num  = $property['ListingId'];
                $address = '';
                $address .= isset($property['St_num'])?$property['St_num'].' ' :'';
                $address .= isset($property['St_dir'])?$property['St_dir'].' ' :'';
                $address .= isset($property['St'])?$property['St'].' ' :'';
                $address .= isset($property['St_sfx'])?$property['St_sfx'].' ' :'';
                $address .= isset($property['Apt_num'])?$property['Apt_num'].' ' :'';
                $FullMailingAddress = $address ;
                $FullMailingAddress .= isset($property['cityname'])?$property['cityname'].' ':'';
                $FullMailingAddress .= isset($property['County'])?$property['County'].' ':'';
                $FullMailingAddress .= isset($property['postalcode'])?$property['postalcode'].' ':'';
                
                $property_address = preg_replace('/\s+/', '-', $FullMailingAddress);
                $property_address = trim($property_address);
                $property_address = str_ireplace("-", " ", $property_address) ;
                $property_address = preg_replace('/\s+/', ' ', $property_address);
                $property_address = preg_replace('/\-+/', ' ', $property_address);
                
                $full_address = str_ireplace(',', ' ', $FullMailingAddress);
                $full_address = preg_replace('/\s+/', ' ', $full_address);
                $full_address = trim($full_address);
                $u_data['slug_url'] = str_ireplace(' ', '-', $full_address);
                $u_data['slug_url'] = str_ireplace(' ', '-', $full_address);
                $u_data['slug_url'] = preg_replace('/[^A-Za-z0-9\-\s]/', '-',$u_data['slug_url']);
                $u_data['slug_url'] = preg_replace('/\-+/','-',$u_data['slug_url']);	
                $u_data['slug_url'] = str_ireplace("/",'-',$u_data['slug_url']);
                $u_data['slug_url'] = str_ireplace("&",'-',$u_data['slug_url']);
                $u_data['slug_url'] = str_ireplace("'",'',$u_data['slug_url']);
              	$u_data['slug_url'] = preg_replace('/\-+/','-',$u_data['slug_url']);
                $u_data['full_address'] = $full_address;
                $u_data['FilteredAddress'] = $full_address;
                
                $prop_address = $FullMailingAddress ;
                echo "   ".$tmp_address = $prop_address ;
                $prop_address = preg_replace('/\s+/',' ',$prop_address);
                $prop_address = preg_replace('/\,/','',$prop_address);
                $prop_address = $prop_address . " CA";
                $address = urlencode($prop_address . " CA");
                $string = $prop_address ;
                $string = str_replace (" ", "+", urlencode($string));
                $mapboxkey = 'sk.eyJ1IjoiMzY1cHJpbnQiLCJhIjoiY2t3d3BxOW50MDY0czJ2cTFzamFpeW5kZSJ9.XDfCTVtS-jlJ_iKBYOdACw';
                $geourl = "https://api.mapbox.com/geocoding/v5/mapbox.places/" . $string . ".json?access_token=".$mapboxkey;
                //$geocode = file_get_contents($geourl);
                $geocode = file_get_contents_curl($geourl);
                
                $output  = json_decode($geocode);
                if (!empty($output->features[0]->center)) {
                    $lat = $output->features[0]->center[1];
                    $lng = $output->features[0]->center[0];
                    $lat = round($lat,17);
                    $lng = round($lng,17);
                    echo "<br> Lat ".$lat . "    Lng ".$lng ;
                    $u_data['Latitude'] = $lat;
                    $u_data['Longitude'] = $lng;
                }
                $dbproperty->where('id', $curr_id);
                $step2 = $dbproperty->update('rets_property_data', $u_data);   
                
            }
        }
            
    }